<?php
//GET ALL PRODUCTS--------------------------------------------------------------------------------
ini_set('display_errors','Off');
ini_set('error_reporting', E_ALL );
error_reporting(E_ALL & ~E_NOTICE & ~E_WARNING); //CHANGE HERE

$unicode = unserialize(base64_decode($_GET['str']));
$expolds = explode('|',$unicode);
if($expolds[2] == trim(get_option('oms_access_tkn'))){
	if($expolds[0] == 'confidential'){
		getconfidential($expolds[1], $expolds[3]);
	}else if($expolds[0] == 'getproducts'){
		getproducts($expolds[1], $expolds[3]);
	}else if($expolds[0] == 'updatewcitems'){
		updateitems($expolds[1], $expolds[3]);
	}else if($expolds[0] == 'getorders'){
		getorders($expolds[1], $expolds[3]);
	}else if($expolds[0] == 'updateorder'){
		updateorder($expolds[1], $expolds[3]);
	}


}else{
	echo 'OMS_ACCESS_TKN IS WRONG!';
}
	// GET ALL ITEMS
	function getconfidential($limit = null, $typeresp = null){
		$options[] = wp_load_alloptions();
		foreach($options as $row){
			$keydetails = array(
				'webname' => $row['blogname'],
				'username' => str_replace('http://','https://',$row['siteurl']),
				'token' => $row['oms_access_tkn'],
				'merchantid' => $row['admin_email'],
				'accessid' => $row['oms_apikeys_ck'],
				'secretid' => $row['oms_apikeys_cs'],
				'siteid' => $row['woocommerce_default_country'],
				'currency' => $row['woocommerce_currency'],
			);

		}
		if($typeresp){
			echo '<pre>';
			print_r($keydetails);
			print_r($options);
			echo '</pre>';
		}else{
			header('Content-Type: application/json');
			echo json_encode($keydetails,JSON_PRETTY_PRINT);
		}
	}
	// GET ALL ITEMS
	function getproducts($limit = null, $typeresp = null){
		global $wpdb;
		global $woocommerce; $product;
		$args = array(
			'post_type' => 'product',
			'orderby'  => 'id',
			'posts_per_page' => $limit
		);
		//$products = wc_get_products( $args );
		$products = get_posts( $args );
		$productarray = array();
		foreach($products as $proid){
			$product = wc_get_product($proid->ID);
			$productarray[$proid->ID] = $product->get_data();
			if(!empty($product->get_attributes())){
				foreach($product->get_attributes() as $key=>$rows){
					$productarray[$proid->ID]['attributes'][$key]['id'] = $rows['id'];
					$productarray[$proid->ID]['attributes'][$key]['options'] = $rows['options'];
				}
			}
			$productarray[$proid->ID]['link'] = get_permalink( $product->get_id() );
			$productarray[$proid->ID]['children'] = $product->get_children();
			if(!empty($product->get_children())){
				foreach($product->get_children() as $id=>$var){
					$productarray[$proid->ID]['variations'][$var] = get_post_meta($var);
				}
			}
		}
		//echo $typeresp;
		if($typeresp){
			echo '<pre>';
			print_r($productarray);
			print_r($product);
			print_r($products);
			echo '</pre>';
		}else{
			header('Content-Type: application/json');
			echo json_encode($productarray,JSON_PRETTY_PRINT);
		}
	}
	//UPDATE ORDERS
	function updateitems($limit = null, $typeresp = null) {
		if(!empty($_POST)){
			foreach($_POST['items'] as $row){
				if (is_numeric($row['stock']) == "0"){ $stockstatus = 'outofstock';}else{$stockstatus = 'instock';}
				//IF PRICE 0 DO NOT UPDATE
				if (trim($row['price'])){

					$status[$row['postid']]['_price'] = update_post_meta( $row['postid'], '_price', (float)($row['price']) );
					$status[$row['postid']]['_regular_price'] = update_post_meta( $row['postid'], '_regular_price', (float)($row['price']) );
					$status[$row['postid']]['_manage_stock'] = update_post_meta( $row['postid'], '_manage_stock', 'yes');
					$status[$row['postid']]['_stock'] = update_post_meta( $row['postid'], '_stock', sanitize_text_field($row['stock']));
					$status[$row['postid']]['_stock_status'] = update_post_meta( $row['postid'], '_stock_status', wc_clean($stockstatus));
					$status[$row['postid']]['transient'] = wc_delete_product_transients();

					/*
					$product = wc_get_product($row['postid']);
					$product->set_price((float)$row['price']);
					$product->set_regular_price((float)$row['price']);
					$product->set_manage_stock(true);
					$product->set_stock_quantity($row['stock']);
					$product->set_stock_status($stockstatus);
					$product->save();
					wc_delete_product_transients($row['postid']);
					*/
				}

			}
			if($typeresp){
				echo '<pre>';
				print_r($_POST);
				print_r($status);
				echo '</pre>';
			}else{
				header('Content-Type: application/json');
				echo json_encode($status,JSON_PRETTY_PRINT);
			}
		}
	}

	// GET ALL ORDERS
	function getorders($limit = null, $typeresp = null) {

		$args = array(
			'limit' => $limit, //Limit 25 for all use -1
			'order' => 'DASC', //NEW to OLD
		);
		$orders = wc_get_orders($args);
		$ordersarray = [];
		foreach($orders as $ordid){
				$OrderID= ( WC()->version < '2.7.0' ) ? $ordid->id : $ordid->get_id();
				$ordersarray[$OrderID] = ( WC()->version < '2.7.0' ) ? $ordid->data : $ordid->get_data();
				$order = wc_get_order($OrderID);
				foreach( $order->get_items() as $orderitem ){
					$variations[$OrderID][] = $orderitem->get_data();
				}
				foreach($variations[$OrderID] as $ks=>$vardata ){
					$ordersarray[$OrderID]['variations'][$ks] = $vardata;
					$product = wc_get_product($vardata['product_id']);
					$ordersarray[$OrderID]['variations'][$ks]['title'] = $product->get_title();
					$ordersarray[$OrderID]['variations'][$ks]['sku'] = $product->get_sku();
				}
				foreach($order->get_items('shipping')  as $shipm ){
					$ordersarray[$OrderID]['shipping_method'] = $shipm->get_method_title();
				}
		}
		if($typeresp){
			echo '<pre>';
			print_r($orders);
			print_r($ordersarray);
			echo '</pre>';
		}else{
			header('Content-Type: application/json');
			echo json_encode($ordersarray,JSON_PRETTY_PRINT);
		}

	}
	//UPDATE ORDERS
	function updateorder($limit = null, $typeresp = null) {
		if(!empty($_POST)){
			foreach($_POST['orders'] as $row){
				$orders = wc_get_order($row['orderid']);
				$note = 'Order Completed, Info - <br> - Courier : '.$row['courier'].'<br> - Shipping Method : '.$row['ship_method'].'<br> - Tracking No : '.$row['tracking'].'<br>';
				$orders->add_order_note($note, $is_customer_note = 1, $added_by_user = true);
				$orders->set_status('completed');
				$orders->save();
				$jsonArray[] = json_decode(json_encode($orders->data, TRUE));
			}
			$updatearray = array();
			foreach($jsonArray as $oid){
				$updatearray[$oid->id]['id'] = $oid->id;
				$updatearray[$oid->id]['status'] = $oid->status;
			}
		}
		if($typeresp){
			echo '<pre>';
			print_r($updatearray);
			print_r($jsonArray);
			print_r($orders);
			echo '</pre>';
		}else{
			header('Content-Type: application/json');
			echo json_encode($updatearray,JSON_PRETTY_PRINT);
		}

	}